#ifndef CONTAINER_H
#define CONTAINER_H

#define CTYPE_SYS    0x00
#define CTYPE_D64    0x01

#include "sizes.h"
#include "includes.h"
#include "dirent.h"

/* dsecription of the surrounding filesys our file is in */
typedef struct container {
    DIR* dir;
    FILE* file;
    int open;

    char* header;
    char* id;

    /* d64 specific things */
    uint8_t track;
    uint8_t sector;
    uint8_t track_link;
    uint8_t sector_link;
    uint8_t detrack;
    uint8_t desector;
    uint8_t desectpos;
    uint16_t free;
    size_t sectpos;
    size_t sectsize;
    uint8_t* sectbuf;
    uint8_t* bam;

    /* dirlist things */
    dirent64** dirlist;
    int dirsize;
    int dirpos;
    int dirpointer;

    int err;
    int err_track;
    int err_sector;
} container;

#endif /* CONTAINER_H */
