#ifndef DEBUG_FUNCS_H
#define DEBUG_FUNCS_H

#include "network.h"
#include "debug.h"
#include "file.h"

void debug_print_packet_in(packet64*, char*);
void debug_print_packet_out(packet64*, char*);
void debug_print_hex(uint8_t*, int, char*, int);
void debug_start_measure(file64* f);
void debug_end_measure(file64* f);

#define debug_message(format,args...);  { if(debug_level) { fprintf(stdout,"DEBUG: %s: %s(): ",__FILE__,__FUNCTION__); fprintf(stdout,format,##args); } }

#define info_message(format,args...);   { if(ENABLE_INFO) { fprintf(stdout,"INFO: "); fprintf(stdout,format,##args); } }

#define fail_message(format,args...);   { if(ENABLE_FAIL) { fprintf(stdout,"FAIL: %s: ",__FILE__); fprintf(stdout,format,##args); } }

#define fatal_message(format,args...);  { if(ENABLE_FATAL) { fprintf(stderr,"FATAL: %s: ",__FILE__); fprintf(stderr,format,##args); exit(2); } }

#endif /* DEBUG_FUNCS_H */
