#include "dirent.h"
#include "macros.h"
#include "debug_funcs.h"
#include "sizes.h"
#include "string_funcs.h"

void dirent_destruct(dirent64* d) {
    if(!d) return;
    free(d);
    d = NULL;
}

dirent64* dirent_create() {
    dirent64* d;
    d = (struct dirent64*)calloc(1, sizeof(struct dirent64));
    return d;
}

int dirent_setup_from_file(dirent64* d, file64* f) {
    f->err = ERR_OK;
    debug_message("setting up dirent '%s'\n", f->petscii_name);
    /* set full name */
    if(f->petscii_name) strncpy(d->d_petscii_name, f->petscii_name, MAX_C64_NAME);
    if(f->ufs_name) strncpy(d->d_ufs_name, f->ufs_name, MAX_FILESPEC);
    d->d_type = f->filetype;
    d->d_blocks = f->blocks;
    d->d_size = f->size;
    d->d_closed = f->closed;
    d->d_locked = f->locked;
    d->d_detrack = f->detrack;
    d->d_desector = f->desector;
    d->d_desectpos = f->desectpos;
    d->d_track = f->track;
    d->d_sector = f->sector;
    return f->err;
}

