#ifndef DRIVE_H
#define DRIVE_H

#include "includes.h"
#include "sizes.h"
#include "network.h"
#include "file.h"
#include "error.h"
#include "buffer.h"

//be able to buffer (and thus unread) a whole packet

typedef struct drive {
    uint8_t job;        //load, save, open, close, none, listen, talk, untalk?
    uint8_t SA;
    uint8_t lfn;
    uint8_t channel;

    file64* files[MAX_LOGICAL_FILES];
    int curr_partition;

    //filespec
    buffer* filespec;
    buffer* status;

    //XXX adjust dynamically be malloc/realloc, ...
    //same for others like command/status/...
    char* chroot[MAX_PARTITIONS];
    char* path[MAX_PARTITIONS];

    char* name;
    __uid_t uid;
    __gid_t gid;
    int umask;
    char ip[17];

    /* output socket */
    int sender_fd;
    struct sockaddr_in sender;

    int buf_size;
    uint8_t buffer[MAX_MTU + 4];

    packet64 in;
    packet64 out;
} drive;

#endif /* DRIVE_H */
