#include "includes.h"
#include "server.h"
#include "config_funcs.h"
#include "server_funcs.h"
#include "debug_funcs.h"

void quit(void) {
//    server_destruct(s);
}

void sigint(int dummy) {
    quit();
    fatal_message("SIGINT caught\n");
}

void sigterm(int dummy) {
    quit();
    fatal_message("SIGTERM caught\n");
}

int main (int argc, char **argv) {
    char config_file[]="/etc/64net.conf";
    server* s = NULL;

    debug_level = 0;

    signal(SIGINT, sigint);
    signal(SIGTERM, sigterm);

    s = server_create();
    info_message("reading config '%s'\n", config_file);
    if(config_read(s,config_file)) exit(2);
    info_message("initializing server\n");
    //XXX errorhandling missing
    server_init(s);
    info_message("starting server\n");
    server_start(s);
    server_destruct(s);
    s = NULL;
    return 0;
}
